# This file is part of CloudControl.
#
# CloudControl is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# CloudControl is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with CloudControl.  If not, see <http://www.gnu.org/licenses/>.

from functools import wraps


def main_thread(func):
    """Decorator for plugin methods that need to be executed in pyev thread.

    Actually anything that has an attribute `main` that points to an instance of
    MainLoop.
    """
    @wraps(func)
    def decorated(self, *args, **kwargs):
        return self.main.call_in_main_thread(func, self, *args, **kwargs)

    return decorated
